package RTC;


/**
* RTC/FsmServiceOperations.java .
* IDL-to-Java\u30b3\u30f3\u30d1\u30a4\u30e9(\u30dd\u30fc\u30bf\u30d6\u30eb)\u3001\u30d0\u30fc\u30b8\u30e7\u30f3"3.2"\u306b\u3088\u3063\u3066\u751f\u6210\u3055\u308c\u307e\u3057\u305f
* idl/LogicalTimeTriggeredEC.idl\u304b\u3089
* 2016\u5e7411\u67081\u65e5 15\u664208\u520620\u79d2 JST
*/


/*!
   * @if jp
   * @brief 
   * @else
   * @brief FsmService
   *
   * @section Description
   *
   * The FsmService interface defines operations necessary for
   * Stimulus Response Processing as an SDO service.
   *
   * @endif
   */
public interface FsmServiceOperations  extends _SDOPackage.SDOServiceOperations
{

  /*!
       * @if jp
       * @brief 
       * @else
       * @brief get_fsm_profile
       *
       * @section Description
       *
       * Get the current state of the FSM.
       *
       * @section Semantics
       *
       * Modifications to the object returned by this operation will not
       * be reflected in the FSM until and unless set_fsm_profile is
       * called.
       *
       * @endif
       */
  RTC.FsmProfile get_fsm_profile ();

  /*!
       * @if jp
       * @brief 
       * @else
       * @brief set_fsm_profile
       *
       * @section Description
       *
       * This operation will be used to modify the behavior of an FSM as
       * described in Stimulus Response Processing.
       *
       * @endif
       */
  RTC.ReturnCode_t set_fsm_profile (RTC.FsmProfile fsm_profile);
} // interface FsmServiceOperations
